<template>
  <div>
    <div class="gva-search-box">
      <el-form :inline="true" :model="searchInfo" class="demo-form-inline" @keyup.enter="onSubmit">
        <el-form-item label="活动名称">
         <el-input v-model="searchInfo.actionName" placeholder="搜索主题" />

        </el-form-item>
        <el-form-item label="活动开始时间">
            
           <el-date-picker v-model="searchInfo.actionStart" type="datetime" placeholder="搜索条件"></el-date-picker>

        </el-form-item>
        <el-form-item label="活动结束时间">
            
           <el-date-picker v-model="searchInfo.actionEnd" type="datetime" placeholder="搜索条件"></el-date-picker>

        </el-form-item>
            <el-form-item label="上下线" prop="isShow">
            <el-select v-model="searchInfo.isShow" clearable placeholder="请选择">
                <el-option
                    key="true"
                    label="是"
                    value="true">
                </el-option>
                <el-option
                    key="false"
                    label="否"
                    value="false">
                </el-option>
            </el-select>
            </el-form-item>
        <el-form-item>
          <el-button type="primary" icon="search" @click="onSubmit">查询</el-button>
          <el-button icon="refresh" @click="onReset">重置</el-button>
        </el-form-item>
      </el-form>
    </div>
    <div class="gva-table-box">
        <div class="gva-btn-list">
            <el-button type="primary" icon="plus" @click="openDialog">新增</el-button>
            <el-popover v-model:visible="deleteVisible" placement="top" width="160">
            <p>确定要删除吗？</p>
            <div style="text-align: right; margin-top: 8px;">
                <el-button type="primary" link @click="deleteVisible = false">取消</el-button>
                <el-button type="primary" @click="onDelete">确定</el-button>
            </div>
            <template #reference>
                <el-button icon="delete" style="margin-left: 10px;" :disabled="!multipleSelection.length" @click="deleteVisible = true">删除</el-button>
            </template>
            </el-popover>
        </div>
        <el-table
        ref="multipleTable"
        style="width: 100%"
        tooltip-effect="dark"
        :data="tableData"
        row-key="ID"
        @selection-change="handleSelectionChange"
        >
        <el-table-column type="selection" width="55" />
        <el-table-column align="left" label="日期" width="180">
            <template #default="scope">{{ formatDate(scope.row.CreatedAt) }}</template>
        </el-table-column>
        <el-table-column align="left" label="课程" prop="cid" width="120" />
        <el-table-column align="left" label="活动名称" prop="actionName" width="120" />
         <el-table-column align="left" label="活动开始时间" width="180">
            <template #default="scope">{{ formatDate(scope.row.actionStart) }}</template>
         </el-table-column>
         <el-table-column align="left" label="活动结束时间" width="180">
            <template #default="scope">{{ formatDate(scope.row.actionEnd) }}</template>
         </el-table-column>
        <el-table-column align="left" label="上下线" prop="isShow" width="120">
            <template #default="scope">{{ formatBoolean(scope.row.isShow) }}</template>
        </el-table-column>
        <el-table-column align="left" label="二维码" prop="qr" width="120" />
        <el-table-column align="left" label="按钮组">
            <template #default="scope">
            <el-button type="primary" link icon="edit" class="table-button" @click="updateCourseActionFunc(scope.row)">变更</el-button>
            <el-button type="primary" link icon="delete" @click="deleteRow(scope.row)">删除</el-button>
            </template>
        </el-table-column>
        </el-table>
        <div class="gva-pagination">
            <el-pagination
            layout="total, sizes, prev, pager, next, jumper"
            :current-page="page"
            :page-size="pageSize"
            :page-sizes="[10, 30, 50, 100]"
            :total="total"
            @current-change="handleCurrentChange"
            @size-change="handleSizeChange"
            />
        </div>
    </div>
    <el-dialog v-model="dialogFormVisible" :before-close="closeDialog" title="添加活动" custom-class="user-dialog">
      <el-form :model="formData" label-position="right" ref="elFormRef" :rules="rule" label-width="80px">
        <el-form-item label="活动名称:"  prop="actionName" >
          <el-input v-model="formData.actionName" :clearable="true"  placeholder="请输入" />
        </el-form-item>
        <el-form-item label="开始时间:"  prop="actionStart" >
          <el-date-picker v-model="formData.actionStart" type="date" style="width:100%" placeholder="选择日期" :clearable="true"  />
        </el-form-item>
        <el-form-item label="结束时间:"  prop="actionEnd" >
          <el-date-picker v-model="formData.actionEnd" type="date" style="width:100%" placeholder="选择日期" :clearable="true"  />
        </el-form-item>
        <el-form-item label="是否上线:"  prop="isShow" >
          <el-switch v-model="formData.isShow" active-color="#13ce66" inactive-color="#ff4949" active-text="是" inactive-text="否" clearable ></el-switch>
        </el-form-item>
        <el-form-item label="图标" label-width="80px">
          <div style="display:inline-block" @click="openBannerChange">
            <img v-if="formData.actionBanner" alt="头像" class="header-img-box" :src="(formData.actionBanner && formData.actionBanner.slice(0, 4) !== 'http')?path+formData.actionBanner:formData.actionBanner">
            <div v-else class="header-img-box">从媒体库选择</div>
          </div>
        </el-form-item>
<!--        <el-form-item label="二维码:"  prop="qr" >-->
<!--          <el-input v-model="formData.qr" :clearable="true"  placeholder="请输入" />-->
<!--        </el-form-item>-->
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button @click="closeDialog">取 消</el-button>
          <el-button type="primary" @click="enterDialog">确 定</el-button>
        </div>
      </template>
    </el-dialog>
    <ChooseImg ref="chooseImg" :target="formData" :target-key="`actionBanner`" />
  </div>
</template>

<script>
export default {
  name: 'CourseAction'
}
</script>

<script setup>
import {
  createCourseAction,
  deleteCourseAction,
  deleteCourseActionByIds,
  updateCourseAction,
  findCourseAction,
  getCourseActionList
} from '@/api/courseAction'

// 全量引入格式化工具 请按需保留

import { getDictFunc, formatDate, formatBoolean, filterDict } from '@/utils/format'
import { ElMessage, ElMessageBox } from 'element-plus'
import { useRoute, onBeforeRouteUpdate  } from 'vue-router'
import { ref, reactive } from 'vue'
import ChooseImg from '@/components/chooseImg/index.vue'

const path = ref(import.meta.env.VITE_BASE_API + '/')

const route = useRoute()
//console.log(route)
onBeforeRouteUpdate((to) => {
  if (to.name === 'courseAction') {
    console.log(to)
    searchInfo.value.cid = to.params.id
    getTableData()
  }
})

// 自动化生成的字典（可能为空）以及字段
const formData = ref({
        cid: 0,
        actionName: '',
        actionStart: new Date(),
        actionEnd: new Date(),
        isShow: false,
        qr: '',
        })

// 验证规则
const rule = reactive({
               actionName : [{
                   required: true,
                   message: '',
                   trigger: ['input','blur'],
               }],
               actionStart : [{
                   required: true,
                   message: '',
                   trigger: ['input','blur'],
               }],
               actionEnd : [{
                   required: true,
                   message: '',
                   trigger: ['input','blur'],
               }],
})

const elFormRef = ref()


// =========== 表格控制部分 ===========
const page = ref(1)
const total = ref(0)
const pageSize = ref(10)
const tableData = ref([])
//const searchInfo = ref({})
const searchInfo = ref({ cid: Number(route.params.id) })

// 重置
const onReset = () => {
  searchInfo.value = { cid: Number(route.params.id) }
  getTableData()
}

// 搜索
const onSubmit = () => {
  page.value = 1
  pageSize.value = 10
  if (searchInfo.value.isShow === ""){
      searchInfo.value.isShow=null
  }
  getTableData()
}

// 分页
const handleSizeChange = (val) => {
  pageSize.value = val
  getTableData()
}

// 修改页面容量
const handleCurrentChange = (val) => {
  page.value = val
  getTableData()
}

// 查询
const getTableData = async() => {
  const table = await getCourseActionList({ page: page.value, pageSize: pageSize.value, ...searchInfo.value })
  if (table.code === 0) {
    tableData.value = table.data.list
    total.value = table.data.total
    page.value = table.data.page
    pageSize.value = table.data.pageSize
  }
}

getTableData()

// ============== 表格控制部分结束 ===============

// 获取需要的字典 可能为空 按需保留
const setOptions = async () =>{
}

// 获取需要的字典 可能为空 按需保留
setOptions()

const chooseImg = ref(null)
const openBannerChange = () => {
  chooseImg.value.open()
}

// 多选数据
const multipleSelection = ref([])
// 多选
const handleSelectionChange = (val) => {
    multipleSelection.value = val
}

// 删除行
const deleteRow = (row) => {
    ElMessageBox.confirm('确定要删除吗?', '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
    }).then(() => {
            deleteCourseActionFunc(row)
        })
    }


// 批量删除控制标记
const deleteVisible = ref(false)

// 多选删除
const onDelete = async() => {
      const ids = []
      if (multipleSelection.value.length === 0) {
        ElMessage({
          type: 'warning',
          message: '请选择要删除的数据'
        })
        return
      }
      multipleSelection.value &&
        multipleSelection.value.map(item => {
          ids.push(item.ID)
        })
      const res = await deleteCourseActionByIds({ ids })
      if (res.code === 0) {
        ElMessage({
          type: 'success',
          message: '删除成功'
        })
        if (tableData.value.length === ids.length && page.value > 1) {
          page.value--
        }
        deleteVisible.value = false
        getTableData()
      }
    }

// 行为控制标记（弹窗内部需要增还是改）
const type = ref('')

// 更新行
const updateCourseActionFunc = async(row) => {
    const res = await findCourseAction({ ID: row.ID })
    type.value = 'update'
    if (res.code === 0) {
        formData.value = res.data.recourseAction
        dialogFormVisible.value = true
    }
}


// 删除行
const deleteCourseActionFunc = async (row) => {
    const res = await deleteCourseAction({ ID: row.ID })
    if (res.code === 0) {
        ElMessage({
                type: 'success',
                message: '删除成功'
            })
            if (tableData.value.length === 1 && page.value > 1) {
            page.value--
        }
        getTableData()
    }
}

// 弹窗控制标记
const dialogFormVisible = ref(false)

// 打开弹窗
const openDialog = () => {
    type.value = 'create'
    dialogFormVisible.value = true
}

// 关闭弹窗
const closeDialog = () => {
    dialogFormVisible.value = false
    formData.value = {
        cid: 0,
        actionName: '',
        actionStart: new Date(),
        actionEnd: new Date(),
        isShow: false,
        qr: '',
        }
}
// 弹窗确定
const enterDialog = async () => {
  formData.value.cid = Number(route.params.id)
     elFormRef.value?.validate( async (valid) => {
             if (!valid) return
              let res
              switch (type.value) {
                case 'create':
                  res = await createCourseAction(formData.value)
                  break
                case 'update':
                  res = await updateCourseAction(formData.value)
                  break
                default:
                  res = await createCourseAction(formData.value)
                  break
              }
              if (res.code === 0) {
                ElMessage({
                  type: 'success',
                  message: '创建/更改成功'
                })
                closeDialog()
                getTableData()
              }
      })
}
</script>

<style lang="scss">
.user-dialog {
  .header-img-box {
    width: 200px;
    height: 200px;
    border: 1px dashed #ccc;
    border-radius: 20px;
    text-align: center;
    line-height: 200px;
    cursor: pointer;
  }
  .avatar-uploader .el-upload:hover {
    border-color: #409eff;
  }
  .avatar-uploader-icon {
    border: 1px dashed #d9d9d9 !important;
    border-radius: 6px;
    font-size: 28px;
    color: #8c939d;
    width: 178px;
    height: 178px;
    line-height: 178px;
    text-align: center;
  }
  .avatar {
    width: 178px;
    height: 178px;
    display: block;
  }
}
.nickName{
  display: flex;
  justify-content: flex-start;
  align-items: center;
}
.pointer{
  cursor: pointer;
  font-size: 16px;
  margin-left: 2px;
}
</style>
